﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace SfSchedule.Models
{
    public class Appointment : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;
        void Set<T>(ref T field, T value, [CallerMemberName] string propertyName = "")
        {
            if (!Equals(field, value))
            {
                field = value;
                if (!string.IsNullOrWhiteSpace(propertyName) && PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
        private int _Id;
        public int Id { get => _Id; set => Set(ref _Id, value); }
        private int _UserId;
        public int UserId { get => _UserId; set => Set(ref _UserId, value); }
        private DateTime _Starts;
        public DateTime Starts { get => _Starts; set => Set(ref _Starts, value); }
        private DateTime _Ends;
        public DateTime Ends { get => _Ends; set => Set(ref _Ends, value); }
        private string _Subject;
        public string Subject { get => _Subject; set => Set(ref _Subject, value); }
        private string _Notes;
        public string Notes { get => _Notes; set => Set(ref _Notes, value); }

        private ObservableCollection<User> _Resources = new ObservableCollection<User>();
        public ObservableCollection<User> Resources { get => _Resources; set => Set(ref _Resources, value); }
    }
}
